/*
 * FIPS 140 compliance
 *
 * Copyright (c) 2012 Red Hat <pmoore@redhat.com>
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

#include "fips.h"

static bool fips_enabled = false;

void fips_set_state(bool requested)
{
#ifdef __linux__
    if (requested) {
        FILE *fds = fopen("/proc/sys/crypto/fips_enabled", "r");
        if (fds != NULL) {
            fips_enabled = (fgetc(fds) == '1');
            fclose(fds);
        }
    }
#else
    fips_enabled = false;
#endif /* __linux__ */

#ifdef _FIPS_DEBUG
    fprintf(stderr, "FIPS mode %s (requested %s)\n",
           (fips_enabled ? "enabled" : "disabled"),
           (requested ? "enabled" : "disabled"));
#endif
}

bool fips_get_state(void)
{
    return fips_enabled;
}
